use std::fs::File;
use std::io::{BufRead, BufReader};

pub fn read_file(name: &str) -> Vec<String> {
    let file = File::open(name);

    return match file {
        Ok(file) => {
            BufReader::new(file).lines().map(|line|line.ok()).flatten().collect::<Vec<_>>()
        }
        Err(_) => {
            vec![]
        }
    }

}